require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_LINUX_MMZONE_H)) {
    eval 'sub _LINUX_MMZONE_H {1;}' unless defined(&_LINUX_MMZONE_H);
    if(defined(&__KERNEL__)) {
	unless(defined(&__ASSEMBLY__)) {
	    require 'linux/config.ph';
	    require 'linux/spinlock.ph';
	    require 'linux/list.ph';
	    require 'linux/wait.ph';
	    require 'linux/cache.ph';
	    require 'linux/threads.ph';
	    require 'linux/numa.ph';
	    require 'linux/init.ph';
	    require 'asm/atomic.ph';
	    unless(defined(&CONFIG_FORCE_MAX_ZONEORDER)) {
		eval 'sub MAX_ORDER {11;}' unless defined(&MAX_ORDER);
	    } else {
		eval 'sub MAX_ORDER { &CONFIG_FORCE_MAX_ZONEORDER;}' unless defined(&MAX_ORDER);
	    }
	    if(defined( &CONFIG_SMP)) {
		eval 'sub ZONE_PADDING {
		    my($name) = @_;
    		    eval q(\'struct zone_padding\' $name;);
		}' unless defined(&ZONE_PADDING);
	    } else {
		eval 'sub ZONE_PADDING {
		    my($name) = @_;
    		    eval q();
		}' unless defined(&ZONE_PADDING);
	    }
	    if(defined(&CONFIG_NUMA)) {
	    }
	    if(defined(&CONFIG_NUMA)) {
		eval 'sub zone_pcp {
		    my($__z, $__cpu) = @_;
    		    eval q((($__z)-> $pageset[($__cpu)]));
		}' unless defined(&zone_pcp);
	    } else {
		eval 'sub zone_pcp {
		    my($__z, $__cpu) = @_;
    		    eval q((($__z)-> $pageset[($__cpu)]));
		}' unless defined(&zone_pcp);
	    }
	    eval 'sub ZONE_DMA {0;}' unless defined(&ZONE_DMA);
	    eval 'sub ZONE_NORMAL {1;}' unless defined(&ZONE_NORMAL);
	    eval 'sub ZONE_HIGHMEM {2;}' unless defined(&ZONE_HIGHMEM);
	    eval 'sub MAX_NR_ZONES {3;}' unless defined(&MAX_NR_ZONES);
	    eval 'sub ZONES_SHIFT {2;}' unless defined(&ZONES_SHIFT);
	    eval 'sub GFP_ZONEMASK {0x3;}' unless defined(&GFP_ZONEMASK);
	    eval 'sub GFP_ZONETYPES {(( &GFP_ZONEMASK + 1) / 2+ 1);}' unless defined(&GFP_ZONETYPES);
	    if(defined(&CONFIG_NUMA)) {
	    } else {
	    }
	    eval 'sub DEF_PRIORITY {12;}' unless defined(&DEF_PRIORITY);
	    if(defined(&CONFIG_FLAT_NODE_MEM_MAP)) {
	    }
	    eval 'sub node_present_pages {
	        my($nid) = @_;
    		eval q(( &NODE_DATA($nid)-> &node_present_pages));
	    }' unless defined(&node_present_pages);
	    eval 'sub node_spanned_pages {
	        my($nid) = @_;
    		eval q(( &NODE_DATA($nid)-> &node_spanned_pages));
	    }' unless defined(&node_spanned_pages);
	    if(defined(&CONFIG_FLAT_NODE_MEM_MAP)) {
		eval 'sub pgdat_page_nr {
		    my($pgdat, $pagenr) = @_;
    		    eval q((($pgdat)-> &node_mem_map + ($pagenr)));
		}' unless defined(&pgdat_page_nr);
	    } else {
		eval 'sub pgdat_page_nr {
		    my($pgdat, $pagenr) = @_;
    		    eval q( &pfn_to_page(($pgdat)-> &node_start_pfn + ($pagenr)));
		}' unless defined(&pgdat_page_nr);
	    }
	    eval 'sub nid_page_nr {
	        my($nid, $pagenr) = @_;
    		eval q( &pgdat_page_nr( &NODE_DATA($nid),($pagenr)));
	    }' unless defined(&nid_page_nr);
	    if(defined(&CONFIG_HAVE_MEMORY_PRESENT)) {
	    } else {
	    }
	    if(defined(&CONFIG_NEED_NODE_MEMMAP_SIZE)) {
	    }
	    eval 'sub zone_idx {
	        my($zone) = @_;
    		eval q((($zone) - ($zone)-> ($zone_pgdat->{node_zones})));
	    }' unless defined(&zone_idx);
	    eval 'sub for_each_pgdat {
	        my($pgdat) = @_;
    		eval q( &for ($pgdat =  &pgdat_list; $pgdat; $pgdat =  ($pgdat->{pgdat_next})));
	    }' unless defined(&for_each_pgdat);
	    eval 'sub for_each_zone {
	        my($zone) = @_;
    		eval q( &for ($zone =  ($pgdat_list->{node_zones}); $zone; $zone =  &next_zone($zone)));
	    }' unless defined(&for_each_zone);
	    eval 'sub is_highmem_idx {
	        my($idx) = @_;
    		eval q({ ($idx ==  &ZONE_HIGHMEM); });
	    }' unless defined(&is_highmem_idx);
	    eval 'sub is_normal_idx {
	        my($idx) = @_;
    		eval q({ ($idx ==  &ZONE_NORMAL); });
	    }' unless defined(&is_normal_idx);
	    eval 'sub is_normal {
	        my($zone) = @_;
    		eval q({ $zone ==  ($zone->{zone_pgdat}->{node_zones}) +  &ZONE_NORMAL; });
	    }' unless defined(&is_normal);
	    require 'linux/topology.ph';
	    eval 'sub numa_node_id () {
	        eval q(( &cpu_to_node( &raw_smp_processor_id())));
	    }' unless defined(&numa_node_id);
	    unless(defined(&CONFIG_NEED_MULTIPLE_NODES)) {
		eval 'sub NODE_DATA {
		    my($nid) = @_;
    		    eval q(( &contig_page_data));
		}' unless defined(&NODE_DATA);
		eval 'sub NODE_MEM_MAP {
		    my($nid) = @_;
    		    eval q( &mem_map);
		}' unless defined(&NODE_MEM_MAP);
		eval 'sub MAX_NODES_SHIFT {1;}' unless defined(&MAX_NODES_SHIFT);
		eval 'sub pfn_to_nid {
		    my($pfn) = @_;
    		    eval q((0));
		}' unless defined(&pfn_to_nid);
	    } else {
		require 'asm/mmzone.ph';
	    }
	    if(defined(&CONFIG_SPARSEMEM)) {
		require 'asm/sparsemem.ph';
	    }
	    if((defined(&BITS_PER_LONG) ? &BITS_PER_LONG : 0) == 32|| defined( &ARCH_HAS_ATOMIC_UNSIGNED)) {
		eval 'sub FLAGS_RESERVED {8;}' unless defined(&FLAGS_RESERVED);
	    }
 elsif((defined(&BITS_PER_LONG) ? &BITS_PER_LONG : 0) == 64) {
		eval 'sub FLAGS_RESERVED {32;}' unless defined(&FLAGS_RESERVED);
	    } else {
		die("BITS_PER_LONG\ not\ defined");
	    }
	    unless(defined(&CONFIG_HAVE_ARCH_EARLY_PFN_TO_NID)) {
		eval 'sub early_pfn_to_nid {
		    my($nid) = @_;
    		    eval q((0));
		}' unless defined(&early_pfn_to_nid);
	    }
	    eval 'sub pfn_to_section_nr {
	        my($pfn) = @_;
    		eval q((($pfn) >>  &PFN_SECTION_SHIFT));
	    }' unless defined(&pfn_to_section_nr);
	    eval 'sub section_nr_to_pfn {
	        my($sec) = @_;
    		eval q((($sec) <<  &PFN_SECTION_SHIFT));
	    }' unless defined(&section_nr_to_pfn);
	    if(defined(&CONFIG_SPARSEMEM)) {
		eval 'sub SECTIONS_SHIFT {( &MAX_PHYSMEM_BITS -  &SECTION_SIZE_BITS);}' unless defined(&SECTIONS_SHIFT);
		eval 'sub PA_SECTION_SHIFT {( &SECTION_SIZE_BITS);}' unless defined(&PA_SECTION_SHIFT);
		eval 'sub PFN_SECTION_SHIFT {( &SECTION_SIZE_BITS -  &PAGE_SHIFT);}' unless defined(&PFN_SECTION_SHIFT);
		eval 'sub NR_MEM_SECTIONS {(1 <<  &SECTIONS_SHIFT);}' unless defined(&NR_MEM_SECTIONS);
		eval 'sub PAGES_PER_SECTION {(1 <<  &PFN_SECTION_SHIFT);}' unless defined(&PAGES_PER_SECTION);
		eval 'sub PAGE_SECTION_MASK {(~( &PAGES_PER_SECTION-1));}' unless defined(&PAGE_SECTION_MASK);
		if(((defined(&MAX_ORDER) ? &MAX_ORDER : 0) - 1+ (defined(&PAGE_SHIFT) ? &PAGE_SHIFT : 0)) > (defined(&SECTION_SIZE_BITS) ? &SECTION_SIZE_BITS : 0)) {
		    die("Allocator\ MAX_ORDER\ exceeds\ SECTION_SIZE");
		}
		eval 'sub mem_section {
		    eval q(* &__nr_to_section {  $mem_section[ &nr]; });
		}' unless defined(&mem_section);
		eval 'sub SECTION_MARKED_PRESENT {(1<<0);}' unless defined(&SECTION_MARKED_PRESENT);
		eval 'sub SECTION_HAS_MEM_MAP {(1<<1);}' unless defined(&SECTION_HAS_MEM_MAP);
		eval 'sub SECTION_MAP_LAST_BIT {(1<<2);}' unless defined(&SECTION_MAP_LAST_BIT);
		eval 'sub SECTION_MAP_MASK {(~( &SECTION_MAP_LAST_BIT-1));}' unless defined(&SECTION_MAP_MASK);
		eval 'sub page {
		    eval q(* &__section_mem_map_addr(\'struct mem_section\' * &section) { my $map =  ($section->{section_mem_map});  $map &=  &SECTION_MAP_MASK;  $map; });
		}' unless defined(&page);
		eval 'sub valid_section {
		    my($section) = @_;
    		    eval q({ ( ($section->{section_mem_map}) &  &SECTION_MARKED_PRESENT); });
		}' unless defined(&valid_section);
		eval 'sub section_has_mem_map {
		    my($section) = @_;
    		    eval q({ ( ($section->{section_mem_map}) &  &SECTION_HAS_MEM_MAP); });
		}' unless defined(&section_has_mem_map);
		eval 'sub valid_section_nr {
		    my($nr) = @_;
    		    eval q({  &valid_section( &__nr_to_section($nr)); });
		}' unless defined(&valid_section_nr);
		eval 'sub kvaddr_to_nid {
		    my($kaddr) = @_;
    		    eval q( &pfn_to_nid( &__pa($kaddr) >>  &PAGE_SHIFT));
		}' unless defined(&kvaddr_to_nid);
		eval 'sub mem_section {
		    eval q(* &__pfn_to_section {  &__nr_to_section( &pfn_to_section_nr( &pfn)); });
		}' unless defined(&mem_section);
		eval 'sub pfn_to_page {
		    my($pfn) = @_;
    		    eval q(({ \'unsigned long __pfn\' = ($pfn);  &__section_mem_map_addr( &__pfn_to_section( &__pfn)) +  &__pfn; }));
		}' unless defined(&pfn_to_page);
		eval 'sub page_to_pfn {
		    my($page) = @_;
    		    eval q(({ $page -  &__section_mem_map_addr( &__nr_to_section(  &page_to_section($page))); }));
		}' unless defined(&page_to_pfn);
		eval 'sub pfn_valid {
		    my($pfn) = @_;
    		    eval q({  &if ( &pfn_to_section_nr($pfn) >=  &NR_MEM_SECTIONS) 0;  &valid_section( &__nr_to_section( &pfn_to_section_nr($pfn))); });
		}' unless defined(&pfn_valid);
		if(defined(&CONFIG_NUMA)) {
		    eval 'sub pfn_to_nid { &early_pfn_to_nid;}' unless defined(&pfn_to_nid);
		}
		eval 'sub pfn_to_pgdat {
		    my($pfn) = @_;
    		    eval q(({  &NODE_DATA( &pfn_to_nid($pfn)); }));
		}' unless defined(&pfn_to_pgdat);
		eval 'sub early_pfn_valid {
		    my($pfn) = @_;
    		    eval q( &pfn_valid($pfn));
		}' unless defined(&early_pfn_valid);
	    } else {
		eval 'sub sparse_init () {
		    eval q( &do {}  &while (0));
		}' unless defined(&sparse_init);
	    }
	    if(defined(&CONFIG_NODES_SPAN_OTHER_NODES)) {
		eval 'sub early_pfn_in_nid {
		    my($pfn, $nid) = @_;
    		    eval q(( &early_pfn_to_nid($pfn) == ($nid)));
		}' unless defined(&early_pfn_in_nid);
	    } else {
		eval 'sub early_pfn_in_nid {
		    my($pfn, $nid) = @_;
    		    eval q((1));
		}' unless defined(&early_pfn_in_nid);
	    }
	    unless(defined(&early_pfn_valid)) {
		eval 'sub early_pfn_valid {
		    my($pfn) = @_;
    		    eval q((1));
		}' unless defined(&early_pfn_valid);
	    }
	}
    }
}
1;
